#!/bin/csh -f

echo ''
echo -----------------------------------------------
echo ' Host Interface Bridge (HIB) software package'
echo  installation program.
echo -----------------------------------------------

LABEL_RETRY:

set nxhib = 0
echo ${nxhib} > nxhib
set nehib = 0
echo ${nehib} > nehib

LABEL_NGECARDS:
echo ''
echo -n "How many HIBs are you installing?: "
set ngehib = $<
if (${ngehib} < 0) then
  echo incorrect number ${ngehib}
  goto LABEL_NXCARDS
endif
echo ${ngehib} > ngehib

set nhib = ${nxhib}
@ nhib +=  ${nehib}
@ nhib +=  ${ngehib}
if (${nhib} < 1) then
  echo incorrect number ${nhib}
  goto LABEL_NXCARDS
endif
echo ${nhib} > nhib

echo ''
echo "Confirm your choice."
echo "  number of HIBs you are installing : ${nhib}"
echo -n "Are they correct? (y/n): "
set answer = $<
if ( $answer != "y") then
  goto LABEL_RETRY
endif

echo ''
echo -------------------------------
echo Preparing for installation...
echo -------------------------------

cd driver;
./nhib.csh ${nxhib} ${nehib} ${ngehib}
cd ..

echo ''
echo done


echo ''
echo ------------------------------------
echo Installing HIB device driver...
echo ------------------------------------
echo ''

cd driver
make clean >& /dev/null
make
set s = ${status}
cd ..
if (${s} != 0) then
  echo ''
  echo -----------------------
  echo 'Installation failed.'
  echo -----------------------
  exit 1
endif

echo ''
echo done
echo ''

echo ''
echo --------------------------
echo Installing HIB library...
echo --------------------------
echo ''
cd hibutil
make clean >& /dev/null
make
set s = ${status}
cd ..
if (${s} != 0) then
  echo ''
  echo -----------------------
  echo 'Installation failed.'
  echo -----------------------
  exit 1
endif

echo ''
echo done
echo ''

#
echo ''
echo  -------------------------------------------------------------------------------
echo 'All installation process has been completed.'
echo 'Now you can check the functions of HIB(s)'
echo 'following the procedure below:'
echo ''
echo '(1) [Root Permission Required]'
echo '    Change directory to ./driver, and then type'
echo '      make installmodule'
echo '    This will plug in the device driver, hibdrv, into the Linux kernel.'
echo ''
echo '(2) [Root Permission Required]'
echo '    Change directory to ./hibutil, and then type'
echo '      ./setmtrr.csh'
echo '    This will set MTRR (memory type range register) of the host'
echo '    computer, causing significant improvement of data transfer speed.'
echo ''
echo '(3) In ./hibutil directory, use hibtest command to test the HIBs. Try'
echo '      ./hibtest'
echo '    and you will see how it works.'
echo ''
echo "NOTE THAT STESP (1)-(2) ARE NECESSARY EVERYTIME YOU RESTART THE HOST COMPUTER."
echo  -------------------------------------------------------------------------------
echo ''
