#!/bin/csh -f

echo ''
echo -----------------------------------------------
echo ' Host Interface Bridge (HIB) software package'
echo  installation program.
echo ''
echo  THIS VERSION IS FOR KFCR-INTERNAL USE ONLY.
echo ''
echo -----------------------------------------------

LABEL_RETRY:

LABEL_NXCARDS:
echo ''
echo -n "How many HIBs with PCI-X IP core are you installing?: "
set nxhib = $<
if (${nxhib} < 0) then
  echo incorrect number ${nxhib}
  goto LABEL_NXCARDS
endif
echo ${nxhib} > nxhib

LABEL_NGECARDS:
echo ''
echo -n "How many HIBs with GPCIe are you installing?: "
set ngehib = $<
if (${ngehib} < 0) then
  echo incorrect number ${ngehib}
  goto LABEL_NXCARDS
endif
echo ${ngehib} > ngehib

LABEL_NECARDS:
echo ''
echo -n "How many HIBs with PLDA's PCIe IP core are you installing?: "
set nehib = $<
if (${nehib} < 0) then
  echo incorrect number ${nehib}
  goto LABEL_NXCARDS
endif
echo ${nehib} > nehib

set nhib = ${nxhib}
@ nhib +=  ${nehib}
@ nhib +=  ${ngehib}
if (${nhib} < 1) then
  echo incorrect number ${nhib}
  goto LABEL_NXCARDS
endif
echo ${nhib} > nhib

echo ''
echo "Confirm your choice."
echo "  number of HIBs with PCI-X IP core    : ${nxhib}"
echo "  number of HIBs with GPCIe            : ${ngehib}"
echo "  number of HIBs with PLDA's PCIe core : ${nehib}"
echo "  number of HIBs in total              : ${nhib}"
echo -n "Are they correct? (y/n): "
set answer = $<
if ( $answer != "y") then
  goto LABEL_RETRY
endif

echo ''
echo -------------------------------
echo Preparing for installation...
echo -------------------------------

cd driver;
./nhib.csh ${nxhib} ${nehib} ${ngehib}
cd ..

echo ''
echo done


echo ''
echo ------------------------------------
echo Installing GRAPE-7 device driver...
echo ------------------------------------
echo ''

cd driver
make clean >& /dev/null
make
set s = ${status}
cd ..
if (${s} != 0) then
  echo ''
  echo -----------------------
  echo 'Installation failed.'
  echo -----------------------
  exit 1
endif

echo ''
echo done
echo ''

echo ''
echo --------------------------------------------
echo Installing Host Interface Bridge library...
echo --------------------------------------------
echo ''
cd hibutil
make clean >& /dev/null
make
set s = ${status}
cd ..
if (${s} != 0) then
  echo ''
  echo -----------------------
  echo 'Installation failed.'
  echo -----------------------
  exit 1
endif

echo ''
echo done
echo ''

echo ''
echo -----------------------------
echo Installing G5 library...
echo -----------------------------
echo ''
cd g5util
make clean >& /dev/null
make
set s = ${status}
cd ..
if (${s} != 0) then
  echo ''
  echo -----------------------
  echo 'Installation failed.'
  echo -----------------------
  exit 1
endif

echo ''
echo done
echo ''

echo ''
echo -------------------------------------------------------
echo "Installing a sample code..."
echo " (direct-summation algorithm in C)"
echo -------------------------------------------------------
echo ''
cd direct
make clean >& /dev/null
make
set s = ${status}
cd ..
if (${s} != 0) then
  echo ''
  echo -----------------------
  echo 'Installation failed.'
  echo -----------------------
  exit 1
endif

#
echo ''
echo done
echo ''
echo  -------------------------------------------------------------------------------
echo 'All installation process has been completed.'
echo 'Now you can check the functions of HIB(s)'
echo 'following the procedure below:'
echo ''
echo '(1) [Root Permission Required]'
echo '    Change directory to ./driver, and then type'
echo '      make installmodule'
echo '    This will plug in the device driver, hibdrv, into the Linux kernel.'
echo ''
echo '(2) [Root Permission Required]'
echo '    Change directory to ./hibutil, and then type'
echo '      ./setmtrr.csh'
echo '    This will set MTRR (memory type range register) of the host'
echo '    computer, causing significant improvement of data transfer speed.'
echo ''
echo '(3) In ./hibutil directory, use hibtest command to test the HIBs. Try'
echo '      ./hibtest'
echo '    and you will see how it works.'
echo ''
echo "NOTE THAT STESP (1)-(2) ARE NECESSARY EVERYTIME YOU RESTART THE HOST COMPUTER."
echo  -------------------------------------------------------------------------------
echo ''
